<?php

namespace local_treestudyplan\local\ungradedscanners;

require_once($CFG->dirroot.'/question/engine/states.php'); // for reading question state


class quiz_scanner extends scanner_base {

    protected function get_ungraded_submissions(){
        // count all users who have one or more questions that still need grading
        global $DB;

        // First find all question attempts that need grading
        $sql = "SELECT qza.id as submissionid, qza.userid as userid, qas.questionattemptid as attempt_id, qas.sequencenumber as sequencenumber
                FROM {question_attempt_steps} qas
                JOIN {question_attempts} qna ON qas.questionattemptid = qna.id
                JOIN {quiz_attempts} qza ON qna.questionusageid = qza.uniqueid
                WHERE qas.state = 'needsgrading' AND qza.quiz = {$this->gi->iteminstance}";

        $rs = $DB->get_recordset_sql($sql);
        $submissions = [];
        foreach($rs as $r){
            // Now, check if 
            $maxstate_sql = "SELECT MAX(qas.sequencenumber) FROM {question_attempt_steps} qas WHERE qas.questionattemptid = {$r->attempt_id}";
            $max = $DB->get_field_sql($maxstate_sql);
            if($r->sequencenumber == $max){
                $submissions[$r->userid] = true; // set array index based on user id, to avoid checking if value is in array
            }
        }
        $rs->close();
        return array_keys($submissions);
    }

    public function count_ungraded($course_userids=[]){
        $ungraded = $this->get_ungraded_submissions();
        if(count($course_userids) > 0){
            $ungraded = array_intersect($ungraded,$course_userids);
        }
        return count($ungraded);
    }

    public function count_graded($course_userids=[]){
        // count all users who submitted one or more finished tests.
        global $DB;
        $sql = "SELECT DISTINCT g.userid 
                FROM {grade_grades} g 
                LEFT JOIN {grade_items} gi on g.itemid = gi.id 
                WHERE gi.itemmodule = 'quiz' AND gi.iteminstance = {$this->gi->iteminstance}
                AND g.finalgrade IS NOT NULL"; // MAy turn out to be needed, dunno

        $graded = $DB->get_fieldset_sql($sql);
        
        if(count($course_userids) > 0){
            $graded = array_intersect($graded,$course_userids);
        }
        
        return count($graded);
    }

    public function has_ungraded_submission($userid)
    {
        $ungraded = $this->get_ungraded_submissions();
        return in_array($userid,$ungraded);
    }

}